/*
 *  soapUI, copyright (C) 2004-2007 eviware.com 
 *
 *  soapUI is free software; you can redistribute it and/or modify it under the 
 *  terms of version 2.1 of the GNU Lesser General Public License as published by 
 *  the Free Software Foundation.
 *
 *  soapUI is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
 *  even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *  See the GNU Lesser General Public License for more details at gnu.org.
 */

package com.eviware.soapui.impl.wsdl;

import java.beans.PropertyChangeListener;
import java.io.File;

import com.eviware.soapui.model.iface.Attachment;

/**
 * Behaviour for ModelItems that contain attachments (Requests and MockResponses)
 * 
 * @author ole.matzura
 */

public interface AttachmentContainer
{
	public Attachment attachFile( File file, boolean cache );

	public int getAttachmentCount();

	public Attachment getAttachmentAt( int index );

	public Attachment[] getAttachmentsForPart( String partName );

	public void removeAttachment( Attachment attachment );

	public Attachment[] getAttachments();

	public WsdlAttachmentPart[] getDefinedAttachmentParts();

	public WsdlAttachmentPart getAttachmentPart( String partName );

	public boolean isMtomEnabled();

	public boolean isMultipartEnabled();
	
	public boolean isReadOnly();
	
	public void addAttachmentsChangeListener( PropertyChangeListener listener );
	
	public void removeAttachmentsChangeListener( PropertyChangeListener listener );
}