/*
 *  soapUI, copyright (C) 2004-2007 eviware.com 
 *
 *  soapUI is free software; you can redistribute it and/or modify it under the 
 *  terms of version 2.1 of the GNU Lesser General Public License as published by 
 *  the Free Software Foundation.
 *
 *  soapUI is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
 *  even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *  See the GNU Lesser General Public License for more details at gnu.org.
 */

package com.eviware.soapui.impl.wsdl.actions.iface;

import com.eviware.soapui.impl.wsdl.WsdlInterface;
import com.eviware.soapui.support.action.support.AbstractSoapUIAction;

/**
 * Manages the service endpoints for a WsdlInterface
 * 
 * @author Ole.Matzura
 */

public class InterfaceEndpointsAction extends AbstractSoapUIAction<WsdlInterface>
{
   public InterfaceEndpointsAction()
   {
      super( "Service Endpoints", "Manage service endpoints available for this interface" );
   }

	public void perform( WsdlInterface target, Object param )
	{
		target.getProject().getEndpointStrategy().configure( target );
	}
}
